<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="商品名称" prop="store_name">
                    <el-input v-model="formData.store_name" placeholder="请输入商品名称" />
                </el-form-item>
                <el-form-item label="商品图片" prop="image">
                    <material-picker v-model="formData.image" :limit="1" />
                </el-form-item>
                <el-form-item label="商品价格" prop="price">
                    <el-input v-model="formData.price" placeholder="请输入商品价格" />
                </el-form-item>
                <!-- <el-form-item label="商品条码" prop="bar_code">
                    <el-input v-model="formData.bar_code" placeholder="请输入商品条码" />
                </el-form-item> -->
                <el-form-item label="商品单位" prop="unit">
                    <el-cascader class="w-[500px]" v-model="formData.unit" :options="unitList" :props="{
                    value: 'id',
                    label: 'name',
                    emitPath: false,
                }" placeholder="请选择商品单位" />
                </el-form-item>
                <el-form-item label="商品状态">
                    <el-switch v-model="formData.status" :active-value="1" :inactive-value="0" active-text="上架" inactive-text="下架" inline-prompt />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="storeBranchProductEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiStoreBranchProductAdd, apiStoreBranchProductUpdate, apiStoreBranchProductDetail } from '@/api/store_branch_product'
import { apiStoreProductUnitLists } from "@/api/store_product_unit";
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑门店商品' : '新增门店商品'
})

// 表单数据
const formData = reactive({
    id: '',
    // cate_id: '',
    store_name: '',
    image: '',
    price: '',
    // cost: '',
    // bar_code: '',
    unit: '',
    status: ''
})


// 表单验证
const formRules = reactive<any>({
    cate_id: [{ required: true, message: '请输入商品分类', trigger: 'blur' }],
    store_name: [{ required: true, message: '请输入门店名称', trigger: 'blur' }],
    image: [{ required: true, message: '请输入商品图片', trigger: 'blur' }],
    price: [{ required: true, message: '请输入商品价格', trigger: 'blur' }],
    cost: [{ required: true, message: '请输入商品成本', trigger: 'blur' }],
    bar_code: [{ required: true, message: '请输入商品条码', trigger: 'blur' }],
    unit: [{ required: true, message: '请输入商品单位', trigger: 'blur' }],
    status: [{ required: true, message: '请输入商品状态', trigger: 'blur' }]
})

const unitList = ref([]);
const getUnitList = () => {
    apiStoreProductUnitLists({}).then((res) => {
        unitList.value = res.lists;
    });
};
getUnitList();

// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiStoreBranchProductDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiStoreBranchProductUpdate(data) 
        : await apiStoreBranchProductAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
